
/**********************************************************
Discharging process.
Common routine for capacity measure or storage
The difference is TargeV, value of finishing voltage.
**********************************************************/
void Discharge(void)
{
	uns16 calc16,LocValI,LocalValV,DispI;
	uns16 LocCapa,VI2;
	char Port,Rel,i,j,Checks,LocStat;
	bit Rev;
	uns32 calc32,calcb32;

	hour = 0;
	min = 0;
	sec = 0;
	for (i=0;i!=4;i++)
	{
	 	ADCModule(1);
	 	tempo (5,1);
	 	CurCumul[i] = 0;
	 	j = 0;
	} 
	while (SW1 == 0)
	{
		//HandelKeys();
		if (msflg == 1)
		{
			OpsMs = 1;
			msflg = 0;
			DispCtr++;
			if (DispCtr == DispRefresh) DispCtr = 0;
			Checks++;
			if (Checks == 5)
			{
				Checks = 0;
			}	
			if (Checks == 0)
			{
				ADCModule(1);
			}
		}
		if (secflg == 1)
		{
			OpsSec = 1;
			secflg = 0;
		}


//  *** Precess control and display section *****/		
		if (DispCtr == 0)
		{
			Port++;
			if (Port >= 4) Port = 0;
			// check ports, adapt current or stop process 
			if (Inputs == 4)
			{
				LocStat = State[Port]; 
				if ((LocStat.2 == 0) && (token[Port] == 0))
				{
					AdjustI(Port);
				}		
				LocValI = CalculeAmp(MesI[Port],Port);
				j++;
				if (j == 1000/DispRefresh)	//multiple of DispRefresh to get 1sec)
				//if (j == 5)
				{
					j = 0;
					calcb32 = (uns24)LocValI * 4;
					calc32 = CurCumul[Port];
					calc32+= calcb32;
					CurCumul[Port] = calc32;
				}	
				LocalValV = CalculeVolt(MesV[Port],Port);
				if (VPot[Port] < 5)
				{
					if (token[Port] == 'R') 
					{
						BellTempo (2000);
					}	
					token[Port] = 'P';
					State[Port].6 = 1;
				}	
				else if (LocalValV < TargetV)
				{
					State[Port] |= 0b00101000;
					token[Port] = 'R';
					VPot[Port]--;
					LoadPot(Port);
				}					
			}
			if (Inputs ==2)
			{
				if ((Port != 1) && (Port != 3))
				{
					Rel = Port+1;
					LocStat = State[Port]; 
					if ((LocStat.2 == 0) && (token[Port] == 0))
					{
						AdjustI(Port);
					}	
					LocValI = CalculeAmp(MesI[Port],Port);
					LocStat = State[Rel]; 
					if ((LocStat.2 == 0) && (token[Port] == 0))
					{
						AdjustI(Rel);
					}
					VI2 = CalculeAmp(MesI[Rel],Rel);
					LocValI += VI2;
					j++;
					if (j == 5)
					{
						j = 0;
						calcb32 = (uns24)LocValI * 4;
						calc32 = (uns24)CurCumul[Port];
						calc32+= calcb32;
						CurCumul[Port] = calc32;
					}	
					LocalValV = CalculeVolt(MesV[Port],Port);
					if (VPot[Port] < 5)
					{
						if (token[Port] == 'R') 
						{
							BellTempo (2000);
						}	
						token[Port] = 'P';
						VPot[Rel] = 0;
						LoadPot(Rel);
						State[Port].6 = 1;
					}	
					else if (LocalValV <= TargetV)
					{
						token[Port] = 'R';
						if (VPot[Rel] > 0)
						{
							VPot[Rel]--;
							LoadPot(Rel);
						}
						VPot[Port]--;
						LoadPot(Port);
						State[Port] |= 0b00101000;
					}				
				}
			}	
			if (Inputs == 1)
			{
				if (Port == 0)
				{
					LocalValV = CalculeVolt(MesV[0],0);
					LocValI = 0;
					for (i=0;i!=4;i++)
					{
						Rel = Port+i;
						LocStat = State[Rel]; 
						if ((LocStat.2 == 0) && (token[Port] == 0))
						{
							AdjustI(Rel);
						}
						VI2 = CalculeAmp(MesI[Rel],Rel);
						LocValI += VI2;
					}
					j++;
					if (j == 5)		//each second
					{
						j = 0;
						calcb32 = (uns24)LocValI * 4;
						calc32 = CurCumul[Port];
						calc32+= calcb32;
						CurCumul[Port] = calc32;
					}
					if (VPot[Port] < 5)
					{
						if (token[0] == 'R') 
						{
							BellTempo (2000);
						}	
						token[0] = 'P';
						ClearPot();
						State[0].6 = 1;
					}	
					else if (LocalValV <= TargetV)
					{
						token[0] = 'R';
						State[0] |= 0b00101000;
						for (i=0;i!=4;i++)
						{
							if (VPot[i] > 0)
							{
								VPot[i]--;
								LoadPot(i);
							}
						}	
				
					}					
					
				}	
			}		
// update display
			calc16 = LocalValV;
			DispCtr = 0;
			cvhexbcd (hour);
			txt[0] = dix;
			txt[1] = un;
			txt[2] = ':';
			cvhexbcd (min);
			txt[3] = dix;
			txt[4] = un;
			txt[5] = ':';
			cvhexbcd (sec);
			txt[6] = dix;
			txt[7] = un;
			txt[8] = ' ';
			txt[9] = 0;
			LCDK_PrintLine(1,0,7,0);
			if (DispLgn[Port] !=0) 
			{
				txt[0] = Port+0x30;
				txt[0] ++;
				txt[1] = 0;
				LCDK_PrintLine(FONT8X8,0,DispLgn[Port],0);
				DispI = LocValI / 10;
				cvhexbcd (DispI);
				dispval (2,DispLgn[Port],3,1,1);
				cvhexbcd (calc16/10);
				dispval	(7,DispLgn[Port],4,2,1);
				if (token[Port] != 0)
				{
					txt[0] = token[Port];
					txt[1] = 0;
					LCDK_PrintLine(Font6x8,17,DispLgn[Port],1);
				}
				calc32 = CurCumul[Port];  //1 hour plus compensate Volt Measure
				//LocCapa = ADCCurr[Port];
				calc32 /= 3600;
				LocCapa = (uns16) calc32;
				cvhexbcd (LocCapa);
				txt[0] = mil;
				txt[1] = cent;
				txt[2] = dix;
				txt[3] = un;
				txt[4] = 0;
				LCDK_PrintLine(Font6x8,13,DispLgn[Port],0);	
/*				if (Inputs != 4)
				{
					DispI = VI2 / 10;
					cvhexbcd (DispI);
					dispval (2,4,3,1,1);
				}
*/
			}
		}
		if (OpsSec == 1)
		{
			CalcDegC(); 
			HeatGestion();
			
//			if (HeatStat == 3)
//			{
//				for (i=0;i!=4;i++)
//				{
//					LocStat = State[i];
//					LocStat &= 0xF9;
//					State[i] = LocStat;	
//				}
//				HeatStat = 1;	
//			}	

		}	
	OpsMs = 0;
	OpsSec = 0;
	}	
}

/********************************************************
Balance of elements
*********************************************************/	
void Balance(void)
{
	SW1 = 1;
}

/********************************************************
Calibration procedure
*********************************************************/	
void Calibration(void)
{
	
	bit Imes,Rev,LocMs;
	char i,k,ActionCtr;
	uns16 LocalValV,LocValI,calc16;
	uns32 calc32;
	uns24 calc24;
	size2 const char *point = MenuTxt[0].pt1;
	
	ActionCtr = 0;
	IoRealTime = 0;
	while (SW1 == 0)		//calibrate
	{
		
		HandelKeys();
		HandelRotary ();
	
		if (msflg == 1)
		{
			LocMs = 1;
			msflg = 0;
			Imes = !Imes;
			//if (Imes)
			ADCModule(1);
		}
		//  calibrate voltage
		if (MenuItem == 40)	
		{
			if (LocMs == 1)
			{
				ActionCtr++;
				if (ActionCtr == 5) ActionCtr = 0;
				DispCtr++;
				if (DispCtr == DispRefresh)
				{
					DispCtr = 0;
					for (i = 0;i!=4;i++)
					{
						un = i+0x31;
						dispval (0,i+1,1,0,1);
						LocalValV = MesV[i];
						cvhexbcd (LocalValV);
						dispval	(2,i+1,4,0,0);
						LocalValV = CalculeVolt (LocalValV,i);
						cvhexbcd (LocalValV);
						dispval	(7,i+1,5,2,0);
						cvhexbcd (KVolt[i]);
						dispval	(14,i+1,5,0,0);
					}
					cvhexbcd(RealVolt);
					txt[0] = dmil;
					txt[1] = mil;
					txt[2] = ',';
					txt[3] = cent;
					txt[4] = dix;
					txt[5] = un;
					txt[6] = 0;
					LCDK_PrintLine(FONT8X8,0,7,0);
					switch (VoltStep)
					{
						case 0:
						{
							txt[0] = dmil;
							txt[1] = mil;
							txt[2] = 0;
							LCDK_PrintLine(FONT8X8,0,7,1);
							break;
						}
						case 1:
						{
							txt[0] = cent;
							txt[1] = 0;
							LCDK_PrintLine(FONT8X8,3,7,1);
							break;
						}
						case 2:
						{
							txt[0] = dix;
							txt[1] = 0;
							LCDK_PrintLine(FONT8X8,4,7,1);
							break;
						}
						case 3:
						{
							txt[0] = un;
							txt[1] = 0;
							LCDK_PrintLine(FONT8X8,5,7,1);
							break;
						}			
					}			
				}

			}
			if (RselSWchg == 1)
			{
				RselSWchg = 0;
				VoltStep ++;
				upcntr = 100;
				OldRot = 100;
				if (VoltStep == 4) VoltStep = 0;
			}
			if (OldRot != upcntr)
			{
				Rev = 1;
				if (OldRot > upcntr) Rev =0;
				OldRot = upcntr;
				switch (VoltStep)
				{
					case 0:
					{ 
						if (Rev)
						RealVolt += 1000;
						else RealVolt -= 1000;
						break;
					}
					case 1:
					{
						if (Rev)
						RealVolt += 100;
						else RealVolt -= 100;
						break;
					}
					case 2:
					{
						if (Rev)
						RealVolt += 10;
						else RealVolt -= 10;
						break;
					}	
					case 3:
					{
						if (Rev)
						RealVolt += 1;
						else RealVolt -= 1;
						break;
					}
				}
				
				if (RealVolt > 30000)
				{
					RealVolt = 0;
				}								
			}	
			if (ActionCtr == 0)
				{
					CPort++;
					if (CPort == 4) CPort = 0;
					calc16 = MesV[CPort];
					calc32 = (uns32)calc16 * 1000000;
					calc32 = calc32 / RealVolt;
					calc16.low8 = calc32.low8;
					calc16.high8 = calc32.mid8;
					KVolt[CPort] = calc16;
				}	
	 
			if (SW3 == 1)		//Store Val in EEprom
			{
				for (i=0;i!=4;i++)
				{
					k= i*6;
					calc16 = KVolt[i];
					writeprom(k,calc16.high8);
					writeprom(k+1,calc16.low8);
				}	
				TxtDisp(18,6,point,292,1,0,0);
				SW3 = 0;
			}				
		}
		
		// calibrate current

		if (MenuItem == 41)
		{
			CPort = InputCal - 1;
			if (SW2 == 1)	// Data entry
			{
				SW2 = 0;
				TogglePotMes = !TogglePotMes;
				if (TogglePotMes == 0)
				{
					upcntr = VPot[CPort];
					OldRot = upcntr;
				}
				txt[0] = ':';
				txt[1] = ' ';
				txt[2] = ' ';
				txt[3] = ' ';
				txt[4] = ' ';
				txt[5] = ' ';
				txt[6] = ' ';
				txt[7] = ' ';
				txt[8] = ' ';
				txt[9] = 0;
				txt[10] = 0;
				LCDK_PrintLine(1,9,4,0);
				LCDK_PrintLine(1,9,6,0);	
			}	
			if (LocMs == 1)
			{
				DispCtr++;
				if (DispCtr == DispRefresh)
				{
					DispCtr = 0;
					un = CPort+0x31;
					dispval (0,2,1,0,1);
					calc16 = CCurrent;
					cvhexbcd (CCurrent);
					dispval	(2,2,4,0,1);
					calc16 = CalculeAmp (calc16,CPort);
					cvhexbcd (calc16);
					dispval	(7,2,4,1,1);
					cvhexbcd (KAmp[CPort]);
					dispval	(14,2,4,0,1);
					cvhexbcd (VPot[CPort]);
					if (!TogglePotMes)
					dispval(8,4,3,0,2);
					else
					dispval(11,4,3,0,1);
					cvhexbcd(RealVolt);
					txt[0] = mil;
					txt[1] = ',';
					txt[2] = cent;
					txt[3] = dix;
					txt[4] = un;
					txt[5] = 0;
					if (TogglePotMes)
					LCDK_PrintLine(2,8,6,0);
					else
					LCDK_PrintLine(1,11,6,0);
					switch (VoltStep)
					{
						case 0:
						{
							txt[0] = mil;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,8,6,1);
							break;
						}
						case 1:
						{
							txt[0] = cent;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,10,6,1);
						break;
						}
						case 2:
						{
							txt[0] = dix;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,11,6,1);
							break;
						}
						case 3:
						{
							txt[0] = un;
							txt[1] = 0;
							if (TogglePotMes)
							LCDK_PrintLine(2,12,6,1);
							break;
						}					
					}	
				}
				
				calc24 = (uns24)RealVolt * 1000;
				CCurrent = MesI[CPort];
				calc24 = calc24 / CCurrent;
				calc16.low8 = calc24.low8;
				calc16.high8 = calc24.mid8;
				KAmp[CPort] = calc16;
			}
			if (!TogglePotMes)
			{
				if (OldRot != upcntr)
				{
					i = VPot[CPort];
					Rev = 1;
					if (OldRot > upcntr) Rev =0;
					OldRot = upcntr;
					if (Rev)
					i ++;
					else i --;
					VPot[CPort] = i;
					LoadPot(CPort);
				}
			}	
			else
			{
				if (RselSWchg == 1)
				{
					RselSWchg = 0;
					VoltStep ++;
					upcntr = 100;
					OldRot = 100;
					if (VoltStep == 4) VoltStep = 0;
				}
				if (OldRot != upcntr)
				{
					Rev = 1;
					if (OldRot > upcntr) Rev =0;
					OldRot = upcntr;
					switch (VoltStep)
					{
						case 0:
						{ 
							if (Rev)
							RealVolt += 1000;
							else RealVolt -= 1000;
							break;
						}
						case 1:
						{
							if (Rev)
							RealVolt += 100;
							else RealVolt -= 100;
							break;
						}
						case 2:
						{
							if (Rev)
							RealVolt += 10;
							else RealVolt -= 10;
							break;
						}	
						case 3:
						{
							if (Rev)
							RealVolt += 1;
							else RealVolt -= 1;
							break;
						}
					}
					if (RealVolt > 2000)
					{
						RealVolt = 2000;
					}			
				}	
			}
			if (SW3 == 1)		//Store Val in EEprom
			{
				SW3 = 0;
				i = CPort * 6;
				writeprom(i+2,calc16.high8);
				writeprom(i+3,calc16.low8);
			}	
		}
		
		 // calibrate temperature
		 
		if (MenuItem == 42)	
		{
			SW1 = 1;
		}
		
		// calibrate value electronic potentiometer
		
		if (MenuItem == 43)
		{
			SW1 = 1;		//not implented yet
/*
			if (upcntr > 3) upcntr = 3;
			{
				if (OldRot != upcntr)
				{
					CPort = upcntr;
					VPot[OldRot] = 0;
					LoadPot(OldRot);
					State[OldRot] = 0;
					un = CPort + 0x31;
					dispval (0,3,1,0,Font6x8);
					OldRot = upcntr;
					State[upcntr] = 0x81;
					Curr[upcntr] = Current;
				}		
			}
			LocValI = CalculeAmp (MesI[CPort],CPort);
			ValI[CPort] = LocValI;
			if (OpsMs == 1)
			{
				DispCtr++;
				if (DispCtr == DispRefresh)
				{
					cvhexbcd (LocValI);
					dispval(4,3,4,1,Font6x8);
					cvhexbcd(VPot[CPort]);
					dispval(11,3,3,0,Font6x8);
					calc32 = ValI[CPort];
					calc32 *= 100;
					calc32 /= VPot[CPort];
					calc16.low8 = calc32.low8;
					calc16.high8 = calc32.mid8;	
					cvhexbcd(calc16);
					dispval(9,5,4,0,Font6x8);
					DispCtr = 0;
					
				}
			}
			if (SW3 == 1)	//Memorise value of coef
			{
				calc32 = ValI[CPort];
				calc32 *= 100;
				calc32 /= VPot[CPort];
				calc16.low8 = calc32.low8;
				calc16.high8 = calc32.mid8;	
				i = CPort * 6;
				writeprom(i+4,calc16.high8);
				writeprom(i+5,calc16.low8);		
			}				
			if (SW2	== 1)
			{
				AjTmr = AdjustTimr;
				tempo(50,1);
				TxBuf[0]='1';		// sets all relays to off
				TxBuf[1]=0;		// one measure for the 4 ports
				if (RCIF) i=RCREG1;
				TxData();
				RcvData();		
				while (StatSw2 == 1) HandelKeys();
				SW1 = 1;
				SW2 = 0;
			}*/
			AdjustI(OpsMs);
	
		}
		LocMs = 0;
	}
	IoRealTime = 1;	
	TxBuf[0]='1';		// sets all relays to off
	TxBuf[1]=0b0;		
	if (RCIF) i=RCREG1;
	TxData();
	RcvData('A');
}	

void SlavePerf()
{
	uns16 disptmr,calc16;
	uns24 calc24;
	
	while (SW1 == 0)
	{
		if (msflg == 1)
		{
			OpsMs = 1;
			msflg = 0;
			disptmr++;
			if (disptmr == 500)
			{
				disptmr = 0;
				TxBuf[0] = 7;
				TxData();
				RcvData(7);
				calc24.high8 = RxBuf[2];
				calc24.mid8 = RxBuf[3];
				calc24.low8 = RxBuf[4];
				cvhexbcdL (calc24);
				txt[0] = million;
				txt[1] = cmil;
				txt[2] = dmil;
				txt[3] = mil;
				txt[4] = cent;
				txt[5] = dix;
				txt[6] = un;
				txt[7] = 0;
				LCDK_PrintLine(1,7,1,0);
				TxBuf[0] = 8;
				TxData();
				RcvData(8);
				calc16.high8 = RxBuf[3];
				calc16.low8 = RxBuf[4];
				cvhexbcd (calc16);
				txt[0] = dmil;
				txt[1] = mil;
				txt[2] = cent;
				txt[3] = dix;
				txt[4] = un;
				txt[5] = 0;
				LCDK_PrintLine(1,9,2,0);
			}	
			
		}	
		OpsMs = 0;
	}
}	