/* Multi decharger */
#include "Decharger.h"
#include "int18XXX.H"
#pragma unlockISR
#pragma sharedAllocation

#pragma unlockISR


/***************************************************************
*              CODE
*****************************************************************/

/** V E C T O R  R E M A P P I N G *******************************************/

#pragma origin ResetVector		// specific PICdem with bootloader@ org 0

void dummy (void)
{
#asm
call main
#endasm
}
#pragma origin HIntVector

interrupt High_int_server( void)
{
	High_Int();
	#pragma fastMode
}

#pragma origin LIntVector

interrupt Low_Int_Server(void)
{
int_save_registers
	if (TMR2IF)
	{
		if (IoRealTime)
		{
			HandelRotary();
			HandelKeys();
		}
		TMR2IF = 0;
		ms = ms + 1;
		msflg = 1;
		if (ms == 1000)
		{
			LED = !LED;
			sec = sec + 1;
			secflg = 1;
			ms = 0;
			if (sec == 60)
			{
				min = min + 1;
				sec = 0;
				
				if (min == 60)
				{
					hour = hour + 1;
					min = 0;
					if (hour == 24)
					{
						day = day + 1;
						hour = 0;
					}
				}
			}
		}
// tempo 
		if (timer1 == 1)
		{
			tempoms--;
			if (tempoms == 0)
			{
				timer1 = 0;
			}
		}
// tempo2
/*		if (timer2 == 1)
		{
			tempoms2--;
			if (tempoms2 == 0)
			{
				timer2 = 0;
			}
		}*/		

// Beep timer
		if (BTimer == 1)
		{
			BTempo --;
			if (BTempo == 0)
			{
				BTimer = 0;
				BEEP = 0;
			}	
		}	
//debounce
		if (RotaryDebounce != 0)
		{
			RotaryDebounce --;
		}	
		if (SwDebounce != 0)
		{
			SwDebounce --;
		}
//Serial interface timeout
		if (SrlToutFlg == 1)
		{
			SrlTimeout--;
			if (SrlTimeout == 0)
			{
				SrlToutFlg = 0;
			}	
		}	
	}
	if (ADIF)		
	{
		ADIF = 0;
		ADRes.high8= ADRESH;
		ADRes.low8 = ADRESL;
		switch (NextANP)
		{
			case 0:
			{
				MesI0 = ADRes;
			}
			case 1:
			{
				MesI1 = ADRes;
					break;
			}		
			case 2:
			{
				MesI2 = ADRes;
				break;
			}
			case 3:
			{
				MesI3 = ADRes;
				break;
			}
		}
	}
		
int_restore_registers
}

void High_Int(void)
{

}	//end high priority interrup

#include "MATH24.H"
//#if defined Float24
//#include "MATH24F.h"
//#include "MATH24LB.H"
//#else
//#include "MATH32F.H"
//#include "MATH32LB.H"
//#endif
#include "LowLvl.c"
#include "128x64_LCD.c"
#include "Menu.c"
#include "OpsInit.c"
//#include "Ops.c"
#include "OpsExec.c"

/*********************************************
	Selection loop
Check keys and rotary to make decision
- switch Menu pressed : reinit menu
- switch 1 pressed start execution of selection
- rorary switch change calls menu
*********************************************/
void SelectLoop (void)		//menu phase
{
	//HandelRotary ();
	//HandelKeys();

	if (SW2 == 1)
	{
		SW2 = 0;
		InitMenu(1);
	}
	
	if ((Rselchg == 1) || (RselSWchg == 1))
	{
		Menu();
	}

	if (SW1 == 1)
	{
		SW1 = 0;				// key pressed
		tempo(50,1);
		while (PORTSW1 != 1);		//wait key released
		tempo(50,1);
		OpsFlg = 1;				//ops mode 
		OpsStart = 1;			// ops init to be run once
		LCD_Initialize();
		LCDK_Cls(0xff);
		txt[0]='M';
		txt[1]='O';
		txt[2] ='D';
		txt[3] ='E';
		txt[4] =' ';
		txt[5] ='O';
		txt[6] ='P'; 
		txt[7] ='E';
		txt[8] ='R';
		txt[9] ='A';
		txt[10] ='T';
		txt[11] ='I';
		txt[12] ='O';
		txt[13] ='N';
		txt[14]=0;
		txt[15] =0;
		LCDK_PrintLine(1,3,1,1);
		if (MenuItem == 3) MenuItem = 40;
		tempo (1000,1);
		LCDK_Cls(0x00);
	}

}
/*************************************************
	Operations selection
- if opsinit, calls init operations routines once
then slect and starts execution of selected op 
- Scan switch 1 for end of ops, then go back to selectloop
***************************************************/
void OpsLoop (void)			//operation phase
{
	char i,k;

	// then check for abort key	
	if (SW1 == 1)		// stop key
	{
		SW1 = 0;
		tempo(20,1);
		while (PORTSW1 != 1);
		tempo(50,1);
		LCD_Initialize();
		LCDK_Cls(0x00);
		OpsFlg = 0;
		ClearPot();
		InitMenu(1);
		TxBuf[0]='1';
		TxBuf[1]=0;
		if (RCIF) i=RCREG1;
		TxData();
		RcvData();
		VENTILO = 0;
		upcntr = 0;
	}
	else
	if (OpsStart == 1)
	 OpsInit(OpsMs);
	else 
	// OpsExec (OpsMs,OpsSec);
	{
		switch (OpsMode)
		{
			case 1:
			{
				Discharge();
				break;
			}
			case 2:
			{
				Discharge();
				break;
			}
			case 3:
			{
				Balance();
				break;
			}
			case 4:
			{
				Calibration();
				break;
			}
			default:
			{
				SW1 = 1;
				break;
			}				
		}		
	}	
}
		
void InitHard (void)
{
	uns16 tp;
// init clocking system for internal clock
	OSCTUNE = 0x80; //3X PLL ratio mode selected
	OSCCON = 0x70;  //Switch to 16MHz HFINTOSC
	OSCCON2 = 0x10; //Enable PLL, SOSC, PRI OSC drivers turned off
	while(PLLRDY != 1);   //Wait for PLL lock
	ACTCON = 0;  //Enable active clock tuning for USB operation
// all ports as digital at reset
	ANSELA = 0b00001111;		// PORTA 0-3 are analog
	ANSELB = 0;
	ANSELC = 0;
	ANSELD = 0;
	ANSELE = 0;
// turn power off on all periph, must be indivually turned on
	PMD0 = 0xEF;	//ACTMD on
	PMD1 = 0xFF;
	CMP1MD = 1;
	TBLPTRU = 0;
	ADCON1 = 0x0F;		// Default all pins to digital
	WDTCON = 0;
	RBPU = 0;
// init ram
 	clearRAM(); 
// init intrpt
	INTCON = 0;
	INTCON2 = 0;
	INTCON3 = 0;
	PIR1 = 0;
	PIR2 = 0;
	PIE1 = 0;	
	PIE2 = 0;
	IPEN = 1;	
// Set ports io pins
	LATA = 0;
	LATB = 0;
	LATC = 0;
	LATD = 0;
	LATE = 0;
	TRISA= 0b11011111;
	TRISB= 0b00010001;
	TRISC= 0b11111000;
	TRISD= 0b00000000;
	TRISE= 0b11111100;
	LATB.1 =1;
	LCDKW_DI = 1;
	CSPOT1 = 1; 

// init ADC
	ADCMD = 0;
	nop();
	nop();
	ADCON0 = 0b00000001;		// adc on 
	ADCON1 = 0b10000000;		// vref = internal vref

	ADCON2 = 0b10111110;		// right just, tad8, fosc/16
	VREFCON0 = 0b10110011;		// vref = 4.096V
	ADIP = 0;
	ADIE = 1;
	ADIF = 0;					//inrtp enab
	GO = 1;						//dummy measure to clear
// init USB
	USBIF = 0;		// not used up this ver, so clears
	USBIE = 0;
	USBEN = 0;
// init real time clk
	TMR2MD = 0;
	nop();
	nop();
	PR2 = 74;
	T2CON = 0b01001110;
	TMR2IP = 0;
	TMR2IE = 1;			// timer 0 is running now
// init USART
	UARTMD = 0;
	nop();
	nop();
	TXSTA1 = 0b00100100;
	RCSTA1 = 0b10010000;
	BAUDCON1 = 0b00001000;
	tp = (uns16)BAUDGEN;
	SPBRG1 = tp.low8;
	SPBRGH1 = tp.high8;
	RCIE = 0;		// inrpt disable
// turn on interrupts
	INTCON = 0b00000000;
	USBIE = 0;
	GIEH = 1;			// interrupts started
	GIEL = 1;
	tempo(1000,1);
}
void InitVar()
{
	char i,k;
	uns16 tp;
	
	IoRealTime = 1;
	OpsFlg = 0;
	OpsMode = 0;
	VPot[1] = 0;
	VPot[2] = 0;
	VPot[3] = 0;
	VPot[0] = 0;
	CoefA = CA;
	CoefB = CB;
	CoefC = CC;
	AjTmr = AdjustTimr;
//	VCalc = FactV;		// adc 1023 = 4.096 V
	for (i=0;i!=4;i++)
	{ 
		k = i*6;
		tp.high8 = readprom(k+0);
		tp.low8 = readprom(k+1);
		KVolt[i] = tp;
		tp.high8 = readprom(k+2);
		tp.low8 = readprom(k+3);
		KAmp[i] = tp;
		tp.high8 = readprom(4+k);
		tp.low8 = readprom(5+k);
		CoefPot[i] = tp;
	}
	Inputs = 4;
	Elements = 3;
	Current = 1000;
}

void InitSequence (void)
{
	char i;
	uns16 tp;
//	const char *log1 = lo;
	
	LoadPot(0);
	LoadPot(1);
	LoadPot(2);
	LoadPot(3);
	InitRotary ();	
	TRISB.3 = 0;
	LCDK_BACKLIGHT = 1;
	LCD_Initialize();
	PORTD.0 = 0;
	LCDK_Cls(0xff);
	VENTILO = 0;
//	LCDK_FullScreenGraph(*log1);
	LCDK_FullScreenGraph();
	tempo(2500,1);
	// set all pots to 0
//	check comm
	NextMsg = 0;
	TxBuf[0]='1';
	TxBuf[1]=0;
	if (RCIF) i=RCREG1;
	TxData();
	RcvData();
	if (RxStat != 0)
	{
		if ((RxStat == 2) && (RxBuf[0] == 'A'))
		{
			txt[0]='C';
			txt[1]='O';
			txt[2]='M';
			txt[3]='M';
			txt[4]=' ';
			txt[5] ='O';
			txt[6] ='K';
			txt[7] =' ';
			txt[8] =' ';
			txt[9]=0;

			LCDK_PrintLine(FONT8X8,0,7,1);
		}
		else
		{
			cvhexbcd (RxBuf[0]);
			txt[0]='C';
			txt[1]='O';
			txt[2]='M';
			txt[3]='M';
			txt[4]=' ';
			txt[5] ='E';
			txt[6] ='R';
			txt[7] ='R';
			txt[8] ='.'; 
			txt[9] = cent;
			txt[10]= dix;
			txt[11]= un;
			txt[12]=0;
			LCDK_PrintLine(FONT8X8,0,7,1);
		}			
	}
	else 
	{
		txt[0]='R';
		txt[1]='X';
		txt[2]=' ';
		txt[3]='T';
		txt[4]='I';
		txt[5] ='M';
		txt[6] ='E';
		txt[7] ='O';
		txt[8] ='U';
		txt[9] ='T';
		txt[10]=0;
		txt[11]=0;
		LCDK_PrintLine(FONT8X8,0,7,1);		
	}
	ADCModule (0);
	ADCModule (0);
	ADCModule (0);
	ADCModule (0);
	tempo(500,1);
	ADCModule (0);
	ADCModule (0);
	ADCModule (0);
	ADCModule (1);
	BellTempo(100);
	LCDK_Cls(0x00);
	InitMenu(0);
	LED = 1;
	// check com with slave proc.
	TxBuf[0]='1';
	TxBuf[1]=0;
	if (RCIF) i=RCREG1;
	TxData();
	RcvData();
}

			
void main (void)
{
	InitHard();
	InitVar();
	InitSequence();
	while (1)
	{
		if (msflg == 1)
		{
			OpsMs = 1;
			msflg = 0;
// real hardware :
//			ADCModule ();	// continous analog measures
		}
		if (secflg == 1)
		{
			OpsSec = 1;
			secflg = 0;
		}	
		if (OpsFlg == 1)
		{
			OpsLoop();
		}
		else
		{			
			SelectLoop();
		}
		OpsMs = 0;
		OpsSec = 0;
	}	
}	