/* Multi decharger defines and var */
#define Version "V:2.00 "
#define Date __DATE__
#define Hardware "HARD:V1.1"

/********************************************************
	SELECT HERE THE TYPE OF DISPLAY
There a small model (70mm) which needs to comment next line
and a large one (93mm), control of CS lines inverted 
*******************************************************/

//#define LCD_Large

/****************************************************
           CONFIG (If needed, may be commented)
*****************************************************/

//  CONFIG bits  >> clock intr 16mhz pll x 3

#pragma config [0]  = 0x23	//LS48MHZ=1(48mhz sys clk), CPUDIV =00 (no),CFGPLLEN=0 (oscillator direct),PLLSEL=1(pll x 3)
#pragma config [1]  = 0x08	//IESO=0(no osc switchover),FCMEN=0(no clk failsafe),PCLKEN=0(primary clk can be dis),FOSC=1000(internal)
#pragma config [2]  = 0x0A	//LPBOR=0(BRO rst enab),BORV=01(2.5v),BOREN=01(bro crtrld by soft),PWRTEN=0(pwr up tmr ena)
#pragma config [3]  = 0x3E	//WDTPS=1111(max32768),WDTEN=10(soft ctrld)
#pragma config [4]  = 0		//NU
#pragma config [5]  = 0x91	//MCLRE=1(ext reset),SDOMX=0(SDO on RC7),T3CM=1(T3CKI on RC0),PBADEN=0(ANSELB),CCP2MX=1(CCP2 on RC1)
#pragma config [6]  = 0x81	//DEBUG=1(disable),XINST=0(extended instr dis),ICPRT=0(ICPORT dis),LPV=0(low volt ICSP dis),STRVEN=1(stack ovflow reset)
#pragma config [7]  = 0		//NU
// next part is code protection. No protection used.
#pragma config [8]  = 0x0F	//
#pragma config [9]  = 0xC0	//
#pragma config [10] = 0x0F	//
#pragma config [11] = 0xE0	//
#pragma config [12] = 0x0F	//
#pragma config [13] = 0x40	//

// BootLoader mode
//  ********* uncomment one and only one of the 3 following lines.
#define ResetVector 0x1000
#define HIntVector ResetVector + 0x8
#define LIntVector ResetVector + 0x18

/*******************************************************
              P A R A M E T E R S
***************************************************** */
#define CPUCLK					48		// 48 MHz
#define CYCLK					CPUCLK / 4	// Instruction cycle (only valid if cpu div by 4)	

// process value of USART BRG VALUE, BRGH = 1, BRG16 = 1
#define BAUDR			115200L			// value of baud rate needed
#define CONSTBR1		CPUCLK * 1000000L
#define CONSTBR2		CONSTBR1 / BAUDR
#define CONSTBR3		CONSTBR2 / 4L
#define BAUDGEN			CONSTBR3 -1

/********************************************************************
      D E F I N I T I O N S 
     
*********************************************************************/
//#define USBIntf
//#define DEBUG
/****** Hardware *************/
/** 1 2 8 x 6 4   L C D   I N T E R F A C E *******/
#define LCD_DataPort			PORTD
#define LCD_TrisDataPort		TRISD
//#define LCD_LatchDataPort		LATD
//#define LCD_PortInput()		TRISD = 0xFF;
#define LCDKW_CS1				LATE.0	
#define LCDK_RW					LATB.6		
#define LCDKW_CS2				LATE.1	
#define LCDKR_CS1				PORTE.0		
#define LCDKR_CS2				PORTE.1			
#define LCDK_E					LATA.5		 
#define LCDKW_DI				LATB.2
#define LCDKR_DI				PORTB.2	
#define LCDK_RESET				LATE.3
#define LCDK_BACKLIGHT			LATC.0	
// other hardware 			
#define BEEP					LATC.1
#define PORTSW2					PORTB.4
#define PORTSW3					PORTB.0
#define PORTSW1					PORTE.2
#define ON		1
#define OFF		0
#define SELA					PORTA.6
#define SELB					PORTA.7
#define SELSW					PORTA.4
#define CSPOT1					LATB.5
#define SCKL					LATB.1
#define SDOUT					LATB.3
#define LED						PORTB.7
#define VENTILO					LATC.2

/*********** other definitions ************/

#define Float24		//otherwise float 32 is used
// coef A,B,C caracterisc of ntc restistance
#define CA 				0.001217286
#define CB 				0.0001891450
#define CC 				2.006221E-7
//#define FactV 			4.0039		// 4096refv/1023 (not used)
#define KDebounceTmr	20			//20ms debounce
#define RotDebounceTmr	5
#define AdjustTimr		60			// pots fine adjustments timer
#define DispRefresh		200			// refresh of display during ops
#define SrlRcvTout		300			//in ms
/****************************************************************************
		GLOBAL VARIABLES
*****************************************************************************/

uns16 ms;
char sec,min,hour,day;
bit timer1;
uns16 tempoms;
bit msflg,OpsMs,OpsFlg,secflg,OpsStart,OpsSec;
uns16 SrlTimeout;
bit SrlToutFlg;
uns16 MesI0,MesI1,MesI2,MesI3;
bit rochg,IoRealTime;

#pragma rambank 1

char txt[20];
// Low Level
char OpsMode;
bit TxDataFlg,NextMsg;
char RxStat;
char TxBuf[6];
char RxBuf[6];
char dmil,mil,cent,dix,un;
uns16 beeptmp;
char Roldsel,newsel,RotaryDebounce;
char upcntr;
char lclcnt;
bit oldselA,oldselB,Rselchg,oldselSW,RselSWchg;
char VPot[4];
uns16 MesV[4],MesI[4],Curr[4],ADCCurr[4],DiffV[4];
uns32 RealVolt;
uns16 ResValV;
char VoltStep,OldRot;
char OpsComplete;
char NextANP,SlvCntr;
uns16 ADRes;
bit SW1,SW2,SW3;
bit StatSw1,StatSw2,StatSw3;
char SwDebounce;
bit BellFg,BTimer,BellStat,StartBell;
uns16 BTempo;
char BMode;


// ops
// amelioration : elements[3], current[3] for flexibility at each port
char Inputs,Elements;
char token[4];
uns16 Current,CCurrent;
uns16 KVolt[4],KAmp[4];
uns16 ValI[4],ValV[4];
uns16 CoefPot[4];
char DispLgn[4];
char CPort;
char AjTmr;
uns16 MsCtr[4];
char stport;
uns16 TargetV;
uns32 CurCumul[4];
uns16 ATmr;
char InputCal;
char HeatStat;
/* Heat stat 
0 = Normal cold
1 = Fan on, no overheat
2 = overheat situation
3 = overheat ends
*/

char State[4];
/*	Mode 1 or 2
bit 0 : 1 = Battery present on port
bit 1 : 0 = above current correction not yet done
bit 2 : 0 = under current correction not yet done
bit 3 : 1 = hight current action completed this port
bit 4 : 1 = line is not diplayed
bit 5 : 1 = Reduced current for finalization mode
bit 6 : 1 = reduced current completed, action finished
bit 7 : 1 = Port is active. Can be active witouht battery when relays used.
*/
/* Mode 3, resitance */
char ResState,Res2;
char AjComplete,ActionCtr;
/*	Mode 4, calibrate */
bit PotInit; 
	
bit TogglePotMes;
uns16 DispCtr;
char ErrorCode;

// Process temperature
int16 TempADC,Temp; 
#if defined Float24
float24 CoefA,CoefB,CoefC;
#else
float32 CoefA,CoefB,CoefC;
#endif
#pragma rambank 0

/****************************************************************************
		PROCEDURES PROTOTYPES
*****************************************************************************/
void main( void);
void High_Int(void);
void LCDK_PrintLine(char pfont_tbl,char location_x, char LCDLine,bit reverse);
void LCDK_Cls(char vfill);
void HandelRotary (void);
void HandelKeys(void);

/****************************************************************************
		EEPROM VALUES
*****************************************************************************/

#define CDATA_START 0xF00000
#pragma cdata[CDATA_START]
// 0-1 : KVolt 16 bits
// 2-3 : KAmp 16 bits
// 4-5 : mAmp/PotVal (*100) 16bit ex:(mAmp * 1204) / 100
#pragma cdata[] = 0x4791		//37191
#pragma cdata[] = 0xEC09		//2540
#pragma cdata[] = 0x2B04		//1067
#pragma cdata[] = 0xC590		//37061
#pragma cdata[] = 0xEC09		//2630
#pragma cdata[] = 0x0804		//1032
#pragma cdata[] = 0xF98D		//36345
#pragma cdata[] = 0xEC09		//2700
#pragma cdata[] = 0x2004		//1056
#pragma cdata[] = 0x8490		//36996
#pragma cdata[] = 0xEC09		//2670
#pragma cdata[] = 0x1404		//1044
#pragma cdata[0xF000B0]
// ofs 176
#pragma cdata[] = "(c)Robert ","MULLER"," 2019 "//22 car
#pragma cdata[] = "DECHARGER " 	// 10 car
// ofs 208
#pragma cdata[] = Version	// 8 car
#pragma cdata[] = Hardware	// 8 car
#pragma cdata[] = Date		// 12 car
//-------------
